/* Network-Integrated Multimedia Middleware (NMM)
 * http://www.motama.com/nmm.html
 *  
 * Copyright (C) 2006-2007
 * Motama GmbH, Saarbruecken, Germany
 * http://www.motama.com
 *  
 * This file is part of NMM. 
 * 
 * NMM is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; only version 2 of the License.      
 * 
 * NMM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public 
 * License for more details.  
 * 
 * You should have received a copy of the GNU General Public License 
 * along with NMM; if not, write to the Free Software Foundation,    
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#ifndef _NMM_OSDELEMENT_HPP_
#define _NMM_OSDELEMENT_HPP_

#include "nmm/nmm_prefix.hpp"

//#include "nmm/interfaces/video/osd/manager/IWindow.hpp"
#include "nmm/plugins/video/osd/manager/interfaces/IOSDManager.hpp"
#include "nmm/plugins/video/osd/manager/interfaces/IWidgetFactory.hpp"

#include "OSDElementBase.hpp"
#include "visibility.hpp"
namespace NMM {
  
  /**
   * Widget unit.
   * Manages a widget. This class is used on the application side only.
   */
  class DLLEXPORT OSDElement:
    public OSDElementBase {
    
  public:
    OSDElement(IOSDManager* manager, IWidgetFactory* factory);
    virtual ~OSDElement();
    
    Result selectLeft()  { return (SUCCESS); };
    Result selectRight() { return (SUCCESS); };
    Result selectUp()    { return (SUCCESS); };
    Result selectDown()  { return (SUCCESS); };
    string messageID() { return(""); };
    
    void setDimension( unsigned int w, unsigned int h );
    void setPosition( unsigned int x, unsigned int y );
    
    virtual void setHeader(string) {};
    virtual void setColors(uint, uint, uint, uint, uint) {};

    void update() { win->update(); };
    IWindow* getWindow();
    void show();
    void hide();
    bool isHidden();
    
  protected:
    int width, height;
    IOSDManager_var    manager;
    IWidgetFactory_var factory;
    
    IWindow_var        win;
  };
}

#include "nmm/nmm_suffix.hpp"

#endif
